> ## Documentation Index
> Fetch the complete documentation index at: https://developers.telnyx.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List SIM card actions

> This API lists a paginated collection of SIM card actions. It enables exploring a collection of existing asynchronous operations using specific filters.



## OpenAPI

````yaml /openapi/source/external/wireless/wireless.json get /sim_card_actions
openapi: 3.1.0
info:
  version: 2.0.0
  title: Telnyx API
  x-latency-category: responsive
  x-endpoint-cost: light
  description: SIP trunking, SMS, MMS, Call Control and Telephony Data Services.
  contact:
    email: support@telnyx.com
servers:
  - url: https://api.telnyx.com/v2
    description: Version 2.0.0 of the Telnyx API.
security:
  - bearerAuth: []
tags:
  - name: Wireless
    description: Wireless operations
  - name: SIM Cards
    description: SIM Cards operations
  - name: SIM Card Actions
    description: >-
      View SIM card actions, their progress and timestamps using the SIM Card
      Actions API
  - name: SIM Card Groups
    description: SIM Card Groups operations
  - name: SIM Card Group Actions
    description: SIM Card Group actions operations
  - name: SIM Card Orders
    description: SIM Card Orders operations
  - name: Reporting
    description: Wireless reporting operations
  - name: Wireless Regions
    description: Regions for wireless services
  - name: OTA updates
    description: OTA updates operations
  - name: Mobile Network Operators
    description: Mobile network operators operations
  - name: Private Wireless Gateways
    description: Private Wireless Gateways operations
  - name: Wireless Blocklists
    description: Wireless Blocklists operations
  - name: Traffic Policy Profiles
    description: Traffic Policy Profiles operations
paths:
  /sim_card_actions:
    get:
      tags:
        - SIM Card Actions
      summary: List SIM card actions
      description: >-
        This API lists a paginated collection of SIM card actions. It enables
        exploring a collection of existing asynchronous operations using
        specific filters.
      operationId: ListSimCardActions
      parameters:
        - $ref: '#/components/parameters/FilterSIMCardActionsConsolidated'
        - $ref: '#/components/parameters/PageConsolidated'
      responses:
        '200':
          content:
            application/json:
              schema:
                type: object
                properties:
                  data:
                    type: array
                    items:
                      $ref: '#/components/schemas/SIMCardAction'
                  meta:
                    $ref: '#/components/schemas/PaginationMeta'
          description: Successful Response
        '401':
          description: Unauthorized
        default:
          $ref: '#/components/responses/GenericErrorResponse'
      x-codeSamples:
        - lang: JavaScript
          source: |-
            import Telnyx from 'telnyx';

            const client = new Telnyx({
              apiKey: process.env['TELNYX_API_KEY'], // This is the default and can be omitted
            });

            // Automatically fetches more pages as needed.
            for await (const simCardAction of client.simCards.actions.list()) {
              console.log(simCardAction.id);
            }
        - lang: Python
          source: |
            import os
            from telnyx import Telnyx

            client = Telnyx(
                api_key=os.environ.get("TELNYX_API_KEY"),  # This is the default and can be omitted
            )
            page = client.sim_cards.actions.list()
            page = page.data[0]
            print(page.id)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/team-telnyx/telnyx-go\"\n\t\"github.com/team-telnyx/telnyx-go/option\"\n)\n\nfunc main() {\n\tclient := telnyx.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tpage, err := client.SimCards.Actions.List(context.TODO(), telnyx.SimCardActionListParams{})\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", page)\n}\n"
        - lang: Java
          source: |-
            package com.telnyx.sdk.example;

            import com.telnyx.sdk.client.TelnyxClient;
            import com.telnyx.sdk.client.okhttp.TelnyxOkHttpClient;
            import com.telnyx.sdk.models.simcards.actions.ActionListPage;
            import com.telnyx.sdk.models.simcards.actions.ActionListParams;

            public final class Main {
                private Main() {}

                public static void main(String[] args) {
                    TelnyxClient client = TelnyxOkHttpClient.fromEnv();

                    ActionListPage page = client.simCards().actions().list();
                }
            }
        - lang: Ruby
          source: |-
            require "telnyx"

            telnyx = Telnyx::Client.new(api_key: "My API Key")

            page = telnyx.sim_cards.actions.list

            puts(page)
        - lang: PHP
          source: >-
            <?php


            require_once dirname(__DIR__) . '/vendor/autoload.php';


            use Telnyx\Client;

            use Telnyx\Core\Exceptions\APIException;


            $client = new Client(apiKey: getenv('TELNYX_API_KEY') ?: 'My API
            Key');


            try {
              $page = $client->simCards->actions->list(
                filter: [
                  'actionType' => 'disable',
                  'bulkSimCardActionID' => '47a1c2b0-cc7b-4ab1-bb98-b33fb0fc61b9',
                  'simCardID' => '47a1c2b0-cc7b-4ab1-bb98-b33fb0fc61b9',
                  'status' => 'in-progress',
                ],
                pageNumber: 0,
                pageSize: 0,
              );

              var_dump($page);
            } catch (APIException $e) {
              echo $e->getMessage();
            }
        - lang: CLI
          source: |-
            telnyx sim-cards:actions list \
              --api-key 'My API Key'
components:
  parameters:
    FilterSIMCardActionsConsolidated:
      name: filter
      in: query
      explode: true
      description: >-
        Consolidated filter parameter for SIM card actions (deepObject style).
        Originally: filter[sim_card_id], filter[status],
        filter[bulk_sim_card_action_id], filter[action_type]
      schema:
        type: object
        properties:
          sim_card_id:
            type: string
            format: uuid
            example: 47a1c2b0-cc7b-4ab1-bb98-b33fb0fc61b9
            description: A valid SIM card ID.
          status:
            type: string
            enum:
              - in-progress
              - completed
              - failed
            example: in-progress
            description: Filter by a specific status of the resource's lifecycle.
          bulk_sim_card_action_id:
            type: string
            format: uuid
            example: 47a1c2b0-cc7b-4ab1-bb98-b33fb0fc61b9
            description: Filter by a bulk SIM card action ID.
          action_type:
            type: string
            enum:
              - enable
              - enable_standby_sim_card
              - disable
              - set_standby
              - remove_public_ip
              - set_public_ip
              - enable_voice
              - disable_voice
            example: disable
            description: Filter by action type.
    PageConsolidated:
      name: page
      in: query
      explode: true
      description: >-
        Consolidated pagination parameter (deepObject style). Originally:
        page[number], page[size]
      schema:
        type: object
        properties:
          number:
            type: integer
            minimum: 1
            default: 1
            description: The page number to load.
          size:
            type: integer
            minimum: 1
            maximum: 250
            default: 20
            description: The size of the page.
  schemas:
    SIMCardAction:
      type: object
      title: SIMCardAction
      description: >-
        This object represents a SIM card action. It allows tracking the current
        status of an operation that impacts the SIM card.
      properties:
        id:
          $ref: '#/components/schemas/Id'
        record_type:
          type: string
          example: sim_card_action
          readOnly: true
        sim_card_id:
          type: string
          format: uuid
          description: The related SIM card identifier.
          readOnly: true
          example: 6a09cdc3-8948-47f0-aa62-74ac943d6c58
        action_type:
          type: string
          description: |-
            The operation type. It can be one of the following: <br/>
            <ul>
             <li><code>enable</code> - move the SIM card to the <code>enabled</code> status</li>
             <li><code>enable_standby_sim_card</code> - move a SIM card previously on the <code>standby</code> status to the <code>enabled</code> status after it consumes data.</li>
             <li><code>disable</code> - move the SIM card to the <code>disabled</code> status</li>
             <li><code>set_standby</code> - move the SIM card to the <code>standby</code> status</li>
             <li><code>enable_voice</code> - enable voice calling on the SIM card</li>
             <li><code>disable_voice</code> - disable voice calling on the SIM card</li>
             </ul>
          enum:
            - enable
            - enable_standby_sim_card
            - disable
            - set_standby
            - enable_voice
            - disable_voice
          readOnly: true
          example: enable
        status:
          type: object
          properties:
            value:
              type: string
              description: The current status of the SIM card action.
              enum:
                - in-progress
                - completed
                - failed
                - interrupted
              readOnly: true
              example: completed
            reason:
              type: string
              description: >-
                It describes why the SIM card action is in the current status.
                This will be <code>null</code> for self-explanatory statuses,
                such as <code>in-progress</code> and <code>completed</code> but
                will include further information on statuses like
                <code>interrupted</code> and <code>failed</code>.
              readOnly: true
              example: The data limit was exceeded.
        settings:
          type:
            - object
            - 'null'
          description: A JSON object representation of the action params.
          example: {}
          readOnly: true
          additionalProperties: true
        created_at:
          $ref: '#/components/schemas/CreatedAt'
        updated_at:
          $ref: '#/components/schemas/UpdatedAt'
    PaginationMeta:
      type: object
      properties:
        total_pages:
          type: integer
          example: 3
        total_results:
          type: integer
          example: 55
        page_number:
          type: integer
          example: 2
        page_size:
          type: integer
          example: 25
    Id:
      type: string
      format: uuid
      description: Identifies the resource.
      readOnly: true
      example: 6a09cdc3-8948-47f0-aa62-74ac943d6c58
    CreatedAt:
      type: string
      description: ISO 8601 formatted date-time indicating when the resource was created.
      readOnly: true
      example: '2018-02-02T22:25:27.521Z'
    UpdatedAt:
      type: string
      description: ISO 8601 formatted date-time indicating when the resource was updated.
      readOnly: true
      example: '2018-02-02T22:25:27.521Z'
    Errors:
      properties:
        errors:
          type: array
          items:
            $ref: '#/components/schemas/Error'
      type: object
    Error:
      required:
        - code
        - title
      properties:
        code:
          type: string
        title:
          type: string
        detail:
          type: string
        source:
          type: object
          properties:
            pointer:
              description: JSON pointer (RFC6901) to the offending entity.
              type: string
            parameter:
              description: Indicates which query parameter caused the error.
              type: string
        meta:
          type: object
          additionalProperties: true
      type: object
  responses:
    GenericErrorResponse:
      description: Unexpected error
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Errors'
          examples:
            unexpectedError:
              summary: Unexpected API error
              value:
                errors:
                  - code: '10007'
                    title: Unexpected error
                    detail: An unexpected error occured.
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````